######
# for DataAnalysisContens @USER2013
#  by NAKANO., Yasuto. Prof.Dr., KwanseiGakuinUniversity, Japan, 30/Jun/2013
# matrix of team and oponent team
#   tab.win     items: freq of win
#   tab.lose    items: freq of lose
#   tab.draw    items: freq of draw
#   tab.wpoints items: wining points

library(useR2013DAC)
data(laliga)
names(laliga)
#[1] "Season"    "Week"      "HomeTeam"  "AwayTeam"  "HomeGoals" "AwayGoals"
attach(laliga)

#determin win/lose/draw 
HomeGoals - AwayGoals -> goaldifference
goaldifference -> winlose
winlose[goaldifference==0] <- "draw"
winlose[goaldifference>0] <- "homewin"
winlose[goaldifference<0] <- "awaywin"
winlose[is.na(winlose)] <- 'unknown'

#extract names of win/lose/draw teams
Season -> WinTeam
Season -> LoseTeam
WinTeam[winlose=="homewin"] <- HomeTeam[winlose=="homewin"]
WinTeam[winlose=='awaywin'] <- AwayTeam[winlose=='awaywin']
WinTeam[winlose=='draw'] <- NA
WinTeam[winlose=='unknown'] <- NA
LoseTeam[winlose=='homewin'] <- AwayTeam[winlose=='homewin']
LoseTeam[winlose=='awaywin'] <- HomeTeam[winlose=='awaywin']
LoseTeam[winlose=='draw'] <- NA
LoseTeam[winlose=='unknown'] <- NA

#all
table(WinTeam,LoseTeam) -> tab.win
t(tab.win) -> tab.lose
table(HomeTeam[winlose=='draw'],AwayTeam[winlose=='draw'])+t(table(HomeTeam[winlose=='draw'],AwayTeam[winlose=='draw'])) -> tab.draw
tab.win*3+tab.lose*(-3)+tab.draw -> tab.wpoints
tab.wpoints[order(rowSums(tab.wpoints),decreasing=TRUE),order(rowSums(tab.wpoints),decreasing=TRUE)] -> tab.wpoints

#2008/2009
table(WinTeam[Season=='2008/09'],LoseTeam[Season=='2008/09']) -> tab.win.2008
t(tab.win.2008) -> tab.lose.2008
table(HomeTeam[winlose=='draw'&Season=='2008/09'],AwayTeam[winlose=='draw'&Season=='2008/09'])->tab1
dim(tab1) # col lacks 'Sporting Gijón'
cbind(tab1,matrix(rep(0,20),dimnames=list(rownames(tab1),rownames(tab1)[18]))) ->tab2
tab2[,c(1:17,20,18,19)]->tab3
tab3+t(tab3) -> tab.draw.2008
tab.win.2008*3+tab.lose.2008*(-3)+tab.draw.2008 -> tab.wpoints.2008
tab.wpoints.2008[order(rowSums(tab.wpoints.2008),decreasing=TRUE),order(rowSums(tab.wpoints.2008),decreasing=TRUE)] -> tab.wpoints.2008

#2009/2010
table(WinTeam[Season=='2009/10'],LoseTeam[Season=='2009/10']) -> tab.win.2009
t(tab.win.2009) -> tab.lose.2009
table(HomeTeam[winlose=='draw'&Season=='2009/10'],AwayTeam[winlose=='draw'&Season=='2009/10'])->tab1
dim(tab1) # col lacks 'FC Sevilla', row lacks 'Real Madrid CF'
cbind(tab1,matrix(rep(0,19),dimnames=list(rownames(tab1),rownames(tab1)[9]))) ->tab2
tab2[,c(1:8,10:19,9)]->tab3
rbind(tab2,matrix(rep(0,20),nrow=1,dimnames=list(colnames(tab2)[14],colnames(tab2)))) ->tab4
tab4+t(tab4) -> tab.draw.2009
tab.win.2009*3+tab.lose.2009*(-3)+tab.draw.2009 -> tab.wpoints.2009
tab.wpoints.2009[order(rowSums(tab.wpoints.2009),decreasing=TRUE),order(rowSums(tab.wpoints.2009),decreasing=TRUE)] -> tab.wpoints.2009

#2010/2011
table(WinTeam[Season=='2010/11'],LoseTeam[Season=='2010/11']) -> tab.win.2010
t(tab.win.2010) -> tab.lose.2010
table(HomeTeam[winlose=='draw'&Season=='2010/11'],AwayTeam[winlose=='draw'&Season=='2010/11'])->tab1
dim(tab1)
tab1+t(tab1) -> tab.draw.2010
tab.win.2010*3+tab.lose.2010*(-3)+tab.draw.2010 -> tab.wpoints.2010
tab.wpoints.2010[order(rowSums(tab.wpoints.2010),decreasing=TRUE),order(rowSums(tab.wpoints.2010),decreasing=TRUE)] -> tab.wpoints.2010

#2011/2012
table(WinTeam[Season=='2011/12'],LoseTeam[Season=='2011/12']) -> tab.win.2011
t(tab.win.2011) -> tab.lose.2011
table(HomeTeam[winlose=='draw'&Season=='2011/12'],AwayTeam[winlose=='draw'&Season=='2011/12'])->tab1
dim(tab1)
tab1+t(tab1) -> tab.draw.2011
tab.win.2011*3+tab.lose.2011*(-3)+tab.draw.2011 -> tab.wpoints.2011
tab.wpoints.2011[order(rowSums(tab.wpoints.2011),decreasing=TRUE),order(rowSums(tab.wpoints.2011),decreasing=TRUE)] -> tab.wpoints.2011

#2012/2013
table(WinTeam[Season=='2012/13'],LoseTeam[Season=='2012/13']) -> tab.win.2012
t(tab.win.2012) -> tab.lose.2012
table(HomeTeam[winlose=='draw'&Season=='2012/13'],AwayTeam[winlose=='draw'&Season=='2012/13'])->tab1
dim(tab1)
tab1+t(tab1) -> tab.draw.2012
tab.win.2012*3+tab.lose.2012*(-3)+tab.draw.2012 -> tab.wpoints.2012
tab.wpoints.2012[order(rowSums(tab.wpoints.2012),decreasing=TRUE),order(rowSums(tab.wpoints.2012),decreasing=TRUE)] -> tab.wpoints.2012

###
# corresondence analysis
library(ca)
plot(ca(tab.win),map='rowgreen',arrows=c(FALSE,TRUE))
plot(ca(tab.lose),map='rowgreen',arrows=c(FALSE,TRUE))
#plot(ca(exp(tab.wpoints)),map='rowgreen',arrows=c(FALSE,TRUE))

#######################
#network graph of temas
#######################
library(igraph)
# win -> lose relations
graph.adjacency(tab.win,weight=TRUE) -> tab.win.g 
E(tab.win.g)$weight*E(tab.win.g)$weight/10 -> E(tab.win.g)$width
rowSums(tab.win) -> V(tab.win.g)$size 
tkplot(tab.win.g,layout=layout.circle)

# winingpoints relations
graph.adjacency(tab.wpoints,weight=TRUE) -> tab.wpoints.g 
E(tab.wpoints.g)$weight*E(tab.wpoints.g)$weight/50 -> E(tab.wpoints.g)$width 
E(tab.wpoints.g)$color[E(tab.wpoints.g)$weight>=0] <- "Blue"
E(tab.wpoints.g)$color[E(tab.wpoints.g)$weight<=0] <- "Red"
rowSums(tab.wpoints)/10 -> V(tab.wpoints.g)$size 
tkplot(tab.wpoints.g,layout=layout.circle)

# winingpoints relations : morelose
delete.edges(tab.wpoints.g,E(tab.wpoints.g)[E(tab.wpoints.g)$weight>=0]) -> tab.wpoints.g.morelose
E(tab.wpoints.g.morelose)$weight*E(tab.wpoints.g.morelose)$weight/50 -> E(tab.wpoints.g.morelose)$width 
E(tab.wpoints.g.morelose)$color[E(tab.wpoints.g.morelose)$weight>=0] <- "Blue"
E(tab.wpoints.g.morelose)$color[E(tab.wpoints.g.morelose)$weight<=0] <- "Red"
rowSums(tab.wpoints.morelose)/10 -> V(tab.wpoints.g.morelose)$size 
tkplot(tab.wpoints.g.morelose,layout=layout.circle)

# winingpoints relations : morewin
delete.edges(tab.wpoints.g,E(tab.wpoints.g)[E(tab.wpoints.g)$weight<0]) -> tab.wpoints.g.morewin
E(tab.wpoints.g.morewin)$weight*E(tab.wpoints.g.morewin)$weight/50 -> E(tab.wpoints.g.morewin)$width 
E(tab.wpoints.g.morewin)$color[E(tab.wpoints.g.morewin)$weight>=0] <- "Blue"
E(tab.wpoints.g.morewin)$color[E(tab.wpoints.g.morewin)$weight<=0] <- "Red"
rowSums(tab.wpoints.morewin)/10 -> V(tab.wpoints.g.morewin)$size 
tkplot(tab.wpoints.g.morewin,layout=layout.circle)


########
#2008
# win -> lose relations
gd <- tab.win.2008
graph.adjacency(gd,weight=TRUE) -> gd.g
E(gd.g)$weight^3 -> E(gd.g)$width
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations
gd <- tab.wpoints.2008
graph.adjacency(gd,weight=TRUE) -> gd.g
abs(E(gd.g)$weight^3/50) -> E(gd.g)$width 
E(gd.g)$color[E(gd.g)$weight>=0] <- "Blue"
E(gd.g)$color[E(gd.g)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations : morelose
gd <- tab.wpoints.2008
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight>=0]) -> gd.g.morelose
abs(E(gd.g.morelose)$weight^3/50) -> E(gd.g.morelose)$width 
E(gd.g.morelose)$color[E(gd.g.morelose)$weight>=0] <- "Blue"
E(gd.g.morelose)$color[E(gd.g.morelose)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morelose)$size 
tkplot(gd.g.morelose,layout=layout.circle)

# winingpoints relations : morewin
gd <- tab.wpoints.2008
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight<0]) -> gd.g.morewin
abs(E(gd.g.morewin)$weight^3/50) -> E(gd.g.morewin)$width 
E(gd.g.morewin)$color[E(gd.g.morewin)$weight>=0] <- "Blue"
E(gd.g.morewin)$color[E(gd.g.morewin)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morewin)$size 
tkplot(gd.g.morewin,layout=layout.circle)

########
#2009
# win -> lose relations
gd <- tab.win.2009
graph.adjacency(gd,weight=TRUE) -> gd.g
E(gd.g)$weight^3 -> E(gd.g)$width
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations
gd <- tab.wpoints.2009
graph.adjacency(gd,weight=TRUE) -> gd.g
abs(E(gd.g)$weight^3/50) -> E(gd.g)$width 
E(gd.g)$color[E(gd.g)$weight>=0] <- "Blue"
E(gd.g)$color[E(gd.g)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations : morelose
gd <- tab.wpoints.2009
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight>=0]) -> gd.g.morelose
abs(E(gd.g.morelose)$weight^3/50) -> E(gd.g.morelose)$width 
E(gd.g.morelose)$color[E(gd.g.morelose)$weight>=0] <- "Blue"
E(gd.g.morelose)$color[E(gd.g.morelose)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morelose)$size 
tkplot(gd.g.morelose,layout=layout.circle)

# winingpoints relations : morewin
gd <- tab.wpoints.2009
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight<0]) -> gd.g.morewin
abs(E(gd.g.morewin)$weight^3/50) -> E(gd.g.morewin)$width 
E(gd.g.morewin)$color[E(gd.g.morewin)$weight>=0] <- "Blue"
E(gd.g.morewin)$color[E(gd.g.morewin)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morewin)$size 
tkplot(gd.g.morewin,layout=layout.circle)

########
#2010
# win -> lose relations
gd <- tab.win.2010
graph.adjacency(gd,weight=TRUE) -> gd.g
E(gd.g)$weight^3 -> E(gd.g)$width
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations
gd <- tab.wpoints.2010
graph.adjacency(gd,weight=TRUE) -> gd.g
abs(E(gd.g)$weight^3/50) -> E(gd.g)$width 
E(gd.g)$color[E(gd.g)$weight>=0] <- "Blue"
E(gd.g)$color[E(gd.g)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations : morelose
gd <- tab.wpoints.2010
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight>=0]) -> gd.g.morelose
abs(E(gd.g.morelose)$weight^3/50) -> E(gd.g.morelose)$width 
E(gd.g.morelose)$color[E(gd.g.morelose)$weight>=0] <- "Blue"
E(gd.g.morelose)$color[E(gd.g.morelose)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morelose)$size 
tkplot(gd.g.morelose,layout=layout.circle)

# winingpoints relations : morewin
gd <- tab.wpoints.2010
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight<0]) -> gd.g.morewin
abs(E(gd.g.morewin)$weight^3/50) -> E(gd.g.morewin)$width 
E(gd.g.morewin)$color[E(gd.g.morewin)$weight>=0] <- "Blue"
E(gd.g.morewin)$color[E(gd.g.morewin)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morewin)$size 
tkplot(gd.g.morewin,layout=layout.circle)

########
#2011
# win -> lose relations
gd <- tab.win.2011
graph.adjacency(gd,weight=TRUE) -> gd.g
E(gd.g)$weight^3 -> E(gd.g)$width
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations
gd <- tab.wpoints.2011
graph.adjacency(gd,weight=TRUE) -> gd.g
abs(E(gd.g)$weight^3/50) -> E(gd.g)$width 
E(gd.g)$color[E(gd.g)$weight>=0] <- "Blue"
E(gd.g)$color[E(gd.g)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations : morelose
gd <- tab.wpoints.2011
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight>=0]) -> gd.g.morelose
abs(E(gd.g.morelose)$weight^3/50) -> E(gd.g.morelose)$width 
E(gd.g.morelose)$color[E(gd.g.morelose)$weight>=0] <- "Blue"
E(gd.g.morelose)$color[E(gd.g.morelose)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morelose)$size 
tkplot(gd.g.morelose,layout=layout.circle)

# winingpoints relations : morewin
gd <- tab.wpoints.2011
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight<0]) -> gd.g.morewin
abs(E(gd.g.morewin)$weight^3/50) -> E(gd.g.morewin)$width 
E(gd.g.morewin)$color[E(gd.g.morewin)$weight>=0] <- "Blue"
E(gd.g.morewin)$color[E(gd.g.morewin)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morewin)$size 
tkplot(gd.g.morewin,layout=layout.circle)

########
#2012
# win -> lose relations
gd <- tab.win.2012
graph.adjacency(gd,weight=TRUE) -> gd.g
E(gd.g)$weight^3 -> E(gd.g)$width
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations
gd <- tab.wpoints.2012
graph.adjacency(gd,weight=TRUE) -> gd.g
abs(E(gd.g)$weight^3/50) -> E(gd.g)$width 
E(gd.g)$color[E(gd.g)$weight>=0] <- "Blue"
E(gd.g)$color[E(gd.g)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g)$size 
tkplot(gd.g,layout=layout.circle)

# winingpoints relations : morelose
gd <- tab.wpoints.2012
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight>=0]) -> gd.g.morelose
abs(E(gd.g.morelose)$weight^3/50) -> E(gd.g.morelose)$width 
E(gd.g.morelose)$color[E(gd.g.morelose)$weight>=0] <- "Blue"
E(gd.g.morelose)$color[E(gd.g.morelose)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morelose)$size 
tkplot(gd.g.morelose,layout=layout.circle)

# winingpoints relations : morewin
gd <- tab.wpoints.2012
graph.adjacency(gd,weight=TRUE) -> gd.g
delete.edges(gd.g,E(gd.g)[E(gd.g)$weight<0]) -> gd.g.morewin
abs(E(gd.g.morewin)$weight^3/50) -> E(gd.g.morewin)$width 
E(gd.g.morewin)$color[E(gd.g.morewin)$weight>=0] <- "Blue"
E(gd.g.morewin)$color[E(gd.g.morewin)$weight<=0] <- "Red"
rowSums(gd) -> V(gd.g.morewin)$size 
tkplot(gd.g.morewin,layout=layout.circle)


###########################
# sociomatrix plot by sna
library(sna)
plot.sociomatrix(tab.wpoints.2008)
plot.sociomatrix(tab.wpoints.2009)
plot.sociomatrix(tab.wpoints.2010)
plot.sociomatrix(tab.wpoints.2011)
plot.sociomatrix(tab.wpoints.2012)
